# Regrese - modelovn vztahu dvou spojitch veliin

# zvislost vky syna na vce otce
x<-read.csv("vyska.csv", header = TRUE)

# nakreslen bodovho grafu 
plot(x[,"VYSKA"],x[,"VYSKAOTCE"],xlab="Vka syna (cm)",ylab="Vka otce (cm)")

# Nejprve nekauzln vztah
# vpoet kovariance
cov(x[,c("VYSKA","VYSKAOTCE","VYSKAMATKY")])

# vpoet a testy rznch korelanch koeficient
cor(x[,c("VYSKA","VYSKAOTCE","VYSKAMATKY")])
cor(x[,c("VYSKA","VYSKAOTCE","VYSKAMATKY")], method = "spearman")
cor(x[,c("VYSKA","VYSKAOTCE","VYSKAMATKY")], method = "kendal")
cor.test(x[,"VYSKA"], x[,"VYSKAOTCE"], method = "pearson", alternative = "two.sided")
cor.test(x[,"VYSKA"], x[,"VYSKAOTCE"], method = "spearman",alternative = "two.sided")
cor.test(x[,"VYSKA"], x[,"VYSKAOTCE"], method = "kendal",alternative = "two.sided")

# vpoet regresnho modelu - kauzln zvislosti
m<-lm(x[,"VYSKA"]~x[,"VYSKAOTCE"])
# Do grafu pidme pmku modelujc linern zvislost
abline(m)
# zobrazen vsledk regresnho modelu
m
anova(m)
summary(m)

# vpoet interval spolehlivosti koeficient regresnho modelu
confint(m)

# regrese prochzejc potkem
x<-read.csv("SONO.csv", header = TRUE)
m<- lm(x[,"dSONO"]~x[,"dCTAG"]-1)
m
anova(m)
summary(m)
confint(m)
plot(x[,"dCTAG"],x[,"dSONO"],xlab="dCTAG",xlim=c(1.5,6),ylab="dSONO",ylim=c(1.5,6))

# nakreslen dat pro regresn model a pidn odhadnut regresn pmky
m<-lm(x[,"dSONO"]~x[,"dCTAG"])

# pidn regresn pmky
abline(m,lty=2,col="red")
# nyn uvaujme opanou kauzalitu
m<-lm(x[,"dSONO"]~x[,"dCTAG"]-1)
abline(m,col="blue")

x<-read.csv("vyska.csv", header = TRUE)
m<-lm(x[,"VYSKA"]~x[,"VYSKAOTCE"])

# analza rezidu
plot(x[,"VYSKAOTCE"],m$residuals,ylab="residuly - odchylky od modelu",xlab="vka otce")
res<-residuals(m)
# Q-Q graf residu  test jejich normality
qqnorm(res)
qqline(res, col = "red",lwd=2)

# Kolmogorov Smirnovv test normality residu
ks.test(res, "pnorm", mean(res), sd(res))
m<-lm(x[,"VYSKA"]~x[,"VYSKAOTCE"])

# rzn typy residu
d<-cbind(x[,"VYSKA"], residuals(m), rstudent(m), rstandard(m))
colnames(d)<-c("VYSKA","residuals","rstudent","rstandard")
summary(d)
r1<-resid(m)
r2<-rstandard(m)
r3<-rstudent(m)
mea<-c(mean(x[,"VYSKA"]),mean(r1),mean(r2),mean(r3))
names(mea)<-c("VYSKA","resid","rstandard","rstudent")
mea
sd<-c(sd(x[,"VYSKA"]),sd(r1),sd(r2),sd(r3))
names(sd)<-c("VYSKA","resid","rstandard","rstudent")
sd
                 
# testy normality
x<-read.csv("hosi_vsk.csv", header = TRUE)
m0<-lm(x[,"vyska"]~x[,"vek_sk"])

# test normality vky
shapiro.test(x[,"vyska"])

# test normality rezidu
shapiro.test(residuals(m0))
ks.test(x[,"vyska"],"pnorm",mean(x[,"vyska"]),sd(x[,"vyska"]))
ks.test(residuals(m0),"pnorm",mean(residuals(m0)),sd(residuals(m0)))
 
 
library(MASS)
library(lmtest)
x<-read.csv("vyska.csv", header = TRUE)
m<-lm(x[,"VYSKA"]~x[,"VYSKAOTCE"])

# Durbin Wotsonv test 
dwtest(m)

# regrese prochzajc potkem
x<-read.csv("SONO.csv", header = TRUE)
m0<- lm(x[,"dSONO"]~x[,"dCTAG"]-1)
# -1 v modelu zna, e model nem Intercept, e je nucen aby prochzel potkem.
m0
anova(m0)
plot(x[,"dCTAG"],x[,"dSONO"],xlab="dCTAG",xlim=c(0,6),ylab="dSONO",ylim=c(0,6))
abline(m0,col="blue")
m<-lm(x[,"dSONO"]~x[,"dCTAG"])
abline(m,lty=2,col="red")

# analza rezidu zvislosti vky syna na vce otce
x<-read.csv("vyska.csv", header = TRUE)
m<-lm(x[,"VYSKA"]~x[,"VYSKAOTCE"])
plot(x[,"VYSKAOTCE"],m$residuals,ylab="residuly",xlab="vka otce")
res<-residuals(m)
qqnorm(res)
qqline(res, col = "red",lwd=2)
ks.test(res, "pnorm", mean(res), sd(res))
m<-lm(x[,"VYSKA"]~x[,"VYSKAOTCE"])
d<-cbind(x[,"VYSKA"], residuals(m), rstudent(m), rstandard(m))
colnames(d)<-c("VYSKA","residuals","rstudent","rstandard")
summary(d)

# Porovnn vky ve vkovch skupinch (k oven linernho modelu)
#           Porovnn prmr vkovch skupin (ANOVA model)
x<-read.csv("hosi_vsk.csv", header = TRUE)
m0<-lm(x[,"vyska"]~x[,"vek_sk"])
shapiro.test(x[,"vyska"])
shapiro.test(residuals(m0))
ks.test(x[,"vyska"],"pnorm",mean(x[,"vyska"],na.rm=TRUE),sd(x[,"vyska"],na.rm=TRUE))
ks.test(residuals(m0),"pnorm",mean(residuals(m0)),sd(residuals(m0)))

# Vcensobn regrese
x<-read.csv("vyska.csv", header = TRUE)
library(MASS)
library(lmtest)
m<-lm(x[,"VYSKA"]~x[,"VYSKAOTCE"])
dwtest(m)
m<-lm(x[,"VYSKA"]~x[,"VYSKAOTCE"]+x[,"VYSKAMATKY"])
summary(m)
confint(m)
library(ppcor)

# parciln korelace
pcor.test(x[,"VYSKA"],x[,"VYSKAOTCE"],x[,"VYSKAMATKY"])

# koeficient determinace
summary(m)$r.squared

# Adjustovan korelan koeficient
summary(m)$adj.r.squared
# Dl korelace
summary(lm(x[,"VYSKA"]~x[,"VYSKAOTCE"]))
summary(lm(x[,"VYSKA"]~x[,"VYSKAMATKY"]))

# model nelinern regrese
x<-read.csv("teof.csv", header = TRUE)
cas<-x[,"cas"]
konc<-x[,"konc"]

# komprtmentov model pro koncentraci ltky v krvi po subcitlnnm podn
m<-nls(konc~a3*(exp(-a1*(cas))-exp(-a2*(cas))),start = list(a1 = 0.07, a2 = 1.5, a3 = 14))
summary(m)
confint(m)

# nejjednodu model - konstantn koncentrace
mm<-nls(konc~a1,start = list(a1 = 1))
summary(mm)

# porovnn model  m a mm
anova(m,mm)
plot(cas,konc,xlim=c(0,12),ylim=c(0,12))
# jet dokreslen regresn kivky
xp<-(0:150)/10   
yp<-summary(m)$coefficients[3,1]*(exp(-summary(m)$coefficients[1,1]*(xp))-exp(-summary(m)$coefficients[2,1]*(xp)))
lines(xp,yp,col="blue")
# ukzka robustnch metod v regresi
x<-read.csv("SONO.csv", header = TRUE)
library(robustbase)
mr<-lmrob(x[,"dSONO"]~x[,"dCTAG"])
summary(mr)
mr
confint(mr)

# Ukzka nebezpe pouit polynomu
y<-c(0,2,4,6,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8)
x<-1:20
plot(x,y,ylim=c(0,10),xlim=c(0,25),axes=F,xlab="",ylab="")
box()
# polynom 5.stupn
m<-lm(y~x+I(x^2)+I(x^3)+I(x^4)+I(x^5))
p<-(1:300)/10
yp<-NA
for(i in 1:300) {
  yp[i]<- m[[1]][1]+p[i]* m[[1]][2]+(p[i]^2)* m[[1]][3]+(p[i]^3)*m[[1]][4]+
  (p[i]^4)* m[[1]][5] + (p[i]^5)* m[[1]][6]
}
lines(p,yp,col="blue")
# polynom 6.stupn
m<-lm(y~x+I(x^2)+I(x^3)+I(x^4)+I(x^5)+I(x^6))
p<-(1:300)/10
for(i in 1:300) {
  yp[i]<- m[[1]][1]+p[i]* m[[1]][2]+(p[i]^2)* m[[1]][3]+(p[i]^3)*m[[1]][4]+
  (p[i]^4)* m[[1]][5]+ (p[i]^5)* m[[1]][6] + (p[i]^6)* m[[1]][7]
}
lines(p,yp,lty=2,lwd=2,col="red")


# zobrazen cyklickho asovho trendu a jeho vyhlazovn
x<-read.csv("ARI.csv", header = TRUE)
plot(x[,"rt"],x[,"ARI"],pch=3,cex=.3,type="p",xlab="as (rok a tden)",axes=FALSE,ylab="nemocnost ARI",bty="n")
legend(250, 3000, c("pozorovan hodnoty","klouzav prmr (2 roky)", "loes model"),lty = c(NA,1, 3),lwd = c(NA,2,2), pch = c(3,NA,NA),bty = "n",cex=.8)
library(caTools)
lines(x[,"rt"],runmean(x[,"ARI"], 106),lty=1,lwd=2)
lines(loess(ARI ~ rt, x),lty=3,lwd=2)
box()
axis(2)
