# Analza rozpltylu - porovnn vce skupin
#-------------------------------------------------------------------------------
x<-read.csv("HDL_od_sk.csv", header = TRUE)
library(Hmisc)
summary(x[,"HDL"]~x[,"SKOLA"])

# testy shody rozptyl
var.test(x[x[,"SKOLA"]=="A","HDL"],x[x[,"SKOLA"]=="B","HDL"])
bartlett.test(x[,"HDL"]~x[,"SKOLA"])
library(car)
leveneTest(x[,"HDL"]~x[,"SKOLA"])

# vpis popisnch charakteristik
library(Hmisc)
summary(x[,"HDL"]~x[,"SKOLA"])

# analza rozptylu - prmr
m<-lm(x[,"HDL"]~x[,"SKOLA"])
anova(m)
summary(m)

# intervaly spolehlivosti odhadnutch parametr
confint(m)

# analza rozptylu bez interceptu
m0<-lm(x[,"HDL"]~x[,"SKOLA"]-1)
anova(m0)
summary(m0)
# v pedchozm vpotu Intercept padstavoval kolu A. Me bt ale definovn i jinak viz kontrasty

# intervaly spolehlivosti odhadnutch parametr
confint(m0)

# porovnn tchto dvou model
anova(m,m0)
x<-read.csv("pedi.csv", header = TRUE)
# Pozor! data jsou nsimn zmnna, aby mezi skupinami byly njak rozdly
summary(lm(HMOT_POR~as.factor(OKRES)-1,data=x))
okr1<-as.numeric(x[,"OKRES"]==1)
okr2<-as.numeric(x[,"OKRES"]==2)
okr3<-as.numeric(x[,"OKRES"]==3)
okr4<-as.numeric(x[,"OKRES"]==4)
okr5<-as.numeric(x[,"OKRES"]==5)
okr6<-as.numeric(x[,"OKRES"]==6)
x<-cbind(x,okr1,okr2,okr3,okr4,okr5,okr6)

# dva zpsoby stejnho vpotu
summary(lm(HMOT_POR~okr1+okr2+okr3+okr4+okr5+okr6-1,data=x))
summary(lm(HMOT_POR~as.factor(OKRES),data=x))

# zmna "referennho" okresu
x[,"OKRES"]<-as.factor(x[,"OKRES"])
x[,"OKRES"]<-relevel(x[,"OKRES"], ref = "3")
summary(lm(HMOT_POR~as.factor(OKRES),data=x))

# nastaven kontrast
contrasts(x[,"OKRES"]) <- contr.sum(6)
summary(lm(HMOT_POR~as.factor(OKRES),data=x))

# mnohonsobn srovnvn
library(agricolae)
OKRES<-as.factor(x[,"OKRES"])
HM_P<-x[,"HMOT_POR"]
model<-aov(HM_P~OKRES)
model
anova(model)

# Duncanv test mnohonsobnho porovnvn
duncan.test(model,"OKRES",alpha=0.01,console=TRUE)

# neparametrick test porovnn vce skupin
x<-read.csv("HDL_od_sk.csv", header = TRUE)
x<-x[x[,"ODBER"]==1,]
kruskal.test(x[,"HDL"]~x[,"SKOLA"])

# model s interakc
x<-read.csv("NutriSen.csv", header = TRUE)
m1<-lm(x[,"GLUK1"]~x[,"POHL"]*x[,"DIABETES"])
summary(m1)
anova(m1)
library(Hmisc)

# prmry ve skupinch
summary(x[,"GLUK1"]~x[,"POHL"]*x[,"DIABETES"])

# model bez interakce
m0<-lm(x[,"GLUK1"]~x[,"POHL"]+x[,"DIABETES"])
summary(m0)

# porovnn model m0 a m1
anova(m0,m1)
x<-read.csv("HDL_od_sk.csv", header = TRUE)
x<-x[x[,"SKOLA"]=="A",]

# anamza rozptylu,s ruivm faktorem ID je obdobou provho t-testu
m<-lm(x[,"HDL"]~x[,"ODBER"]+as.factor(x[,"ID"]))
summary(m)
anova(m)

# pokud na sejn data mme sprvn pout, musme zaruit, e poad osob je stejn,
# x[,"ODBER"]==1,"HDL"] daj men na stejn osob jako x[,"ODBER"]==2,"HDL"], ...
# prov t-test pak je:
t.test(x[x[,"ODBER"]==1,"HDL"],x[x[,"ODBER"]==2,"HDL"],paired = T)

# porovnn modelu s interakc a bez interakce
x<-read.csv("HDL_od_sk.csv", header = TRUE)
x[,"SEX"]<-as.factor(x[,"SEX"])
x[,"SKOLA"]<-as.factor(x[,"SKOLA"])
x[,"ODBER"]<-as.factor(x[,"ODBER"])
m0<-lm(x[,"HDL"]~x[,"ODBER"]*x[,"SEX"]+x[,"ODBER"]*x[,"SKOLA"])
m1<-lm(x[,"HDL"]~x[,"ODBER"]*x[,"SEX"]*x[,"SKOLA"])
anova(m0,m1)
