# Kvalitativn veliiny
#-------------------------------------------------------------------------------
library(epitools)
library(epiR)
library(psych)

# binomick test porovnn relativn etnosti 1163/26078  s pravdpodobnost 
# nap. s 0,016  - rzn metody      
binom.test(1163, 26078, p = 0.016,alternative = "greater",conf.level = 0.95)
library(Hmisc)
binconf(1163, 26078,method="all")
library(MKmisc)
binomCI(x = 1163, n = 26078, method = "wald")
# kontingenn tabulky
x<-read.csv("pedi.csv", header = TRUE)
# vytvoen tabulky
tab<-table (x[,"PECE_O_D"],x[,"CH12"])
# vytvoen popisu
pece<-c("uspokojiv","pehnan","nedostaten")
AN<-c("Ano","Ne")
dimnames(tab)<-list("Kvalita pe o dt" = pece, "Chze v jednom roce" = AN)
tab
library(epitools)
# vpoet dkovch a sloupcovch sout
table.margins(tab)
# Pozor neastn poad kd a hlavn velmi nzk poty

# vpoet dkovch, sloupcovc a celkovch procent
Ta<-table.margins(tab)
100*Ta[,]/Ta[,3]
100*Ta[,]/Ta[4,]
100*Ta[,]/Ta[4,3]

x<-read.csv("BMI.csv", header = TRUE)
tab<-table(x[,"BMI"],x[,"DIAB"])
AN<-c("Ano","Ne")
dimnames(tab)<-list( "BMI"= AN,  "Diabetes"= AN)
library(epitools)
table.margins(tab)
# cji-kvadrt testy
chisq.test(tab,correct=FALSE)
chisq.test(tab,correct=TRUE)
# Fisherv pesn test pro mal poty
fisher.test(tab)
fisher.test(matrix(c(5,4,0,2),nrow=2,ncol=2))
# P-mid test
ormidp.test(tab[1,1],tab[1,2],tab[2,1],tab[2,2])
# oekvan hodnoty
expected(tab)
# oekvan hodnoty v procentech
100*expected(tab)/sum(tab)
# pozorovan hodnoty v procentech
100*tab/sum(tab)
# vce test kontingenn tabulky
tab2by2.test(tab)
table(x[,"BMI"],x[,"DIAB"])
# pekdovn z sel na text
x[,"BMI"]<-as.factor(x[,"BMI"])
x[,"DIAB"]<-as.factor(x[,"DIAB"])
ex<-c("Ano","Ne")
names(ex)<-c("1","0")
x[,"BMI"]<-ex[x[,"BMI"]]
x[,"DIAB"]<-ex[x[,"DIAB"]]
x[,"BMI"]<-as.factor(x[,"BMI"])
x[,"DIAB"]<-as.factor(x[,"DIAB"])
tab<-table(x[,"BMI"],x[,"DIAB"])
exp<-c("Ne","Ano")
dimnames(tab) <- list("BMI" = exp, "Diabetes" = exp)
table.margins(tab)
# vpoet OR
oddsratio(tab)
# vpoet RR
riskratio(tab)
# vpoet OR, RR, AR, ...
epi.2by2(tab)

# Nyn peteme data pro vpoet McNemarova testu symetrie
x<-read.csv("pedi.csv", header = TRUE)
# dle zmnme kdovn 0/1 na Ne/Ano
ex<-c("Ano","Ne")
names(ex)<-c("1","0")
x[,"INFHCD2"]<-as.factor(x[,"INFHCD2"])
x[,"INFHCD3"]<-as.factor(x[,"INFHCD3"])
x[,"INFHCD2"]<-ex[x[,"INFHCD2"]]
x[,"INFHCD3"]<-ex[x[,"INFHCD3"]]

# Vytvome poadovanou tabulku
tab<-table(x[,"INFHCD2"],x[,"INFHCD3"])
# Zadme popisky sloupc a dek
dimnames(tab) <- list("Ifekty HCD2" = ex, "Infekty HCD3" = ex)
table.margins(tab)
#McNemarv test
mcnemar.test(tab)

tab<-table(x[,"VVKYCLE1"],x[,"VVKYCLE2"])
out <- c("Ano", "Ne")
dimnames(tab) <- list("VVKYCLE1" = out, "VVKYCLE2" = out)
tab
library(epiR)
# Cohenovo kapa - shoda hodnotitel
epi.kappa(tab)

# Simpsonv paradox
tab<-c(4,6,3,5,5,3,9,6) 
dim(tab)<-c(2,2,2)
le<-c("A","B")
sex<-c("Mu","ena")
ex<-c("Ano","Ne")
dimnames(tab) <- list("Lba" = le, "spnost" = ex, "Pohlav" = sex)
tab
tab[,,1]
# vypoteme OR a RR pro jednotliv pohlav
oddsratio.wald(tab[,,1])
riskratio.wald(tab[,,1])
tab[,,2]
oddsratio.wald(tab[,,2])
riskratio.wald(tab[,,2])
# a nyn vypoteme OR a RR pro ob pohlavdohromady
margin.table(tab,c(1,2))
oddsratio.wald(margin.table(tab,c(1,2)))
riskratio.wald(margin.table(tab,c(1,2)))
# Mantel-Haenzelv test pro strtifikovan tabulky (eliminujc ruiv vliv)
mantelhaen.test(tab)
library(epicalc)

# skrningov testy
tab<-c(131,77,150,635)
dim(tab)<-c(2,2)
pm<-c("+","-")
dimnames(tab) <- list("test_H" = pm, "Zl.std." = pm)
tab
library(epiR)
epi.tests(tab, conf.level = 0.95)

# vpoet ROC kivky
x<-read.csv("ROC.csv", header = TRUE)
library(pROC)
ROC <- roc(x[,"S_CTAG50"],x[,"PSV1_2"],plot=TRUE)
ROC