# Analza cenzorovanch dat
#-------------------------------------------------------------------------------
# Anelza peit
x<-read.csv("surv.csv", header = TRUE)
library(survival)
mod<-survfit(Surv(x[,"OS_mes"],x[,"I_OS"])~1) 
summary(mod) 

# mrtnostn tabulky
life.t<-cbind(mod$time,mod$n.risk,mod$n.event,mod$n.censor,mod$surv,mod$std.err,mod$lower,mod$upper)
colnames(life.t)<-c("time","n.risk","n.event","n.censor","surv","std.err","lower","upper")
life.t[1:2,]
life.t[min(which(life.t[,"time"]>2)),]

# Kaplan-Meierv odhad
# jedna skupina
m<-survfit(Surv(x[,"OS_mes"],x[,"I_OS"])~1,type="kaplan-meier")
m
plot(m)

# dv skupiny (ppadn i vce)
m<-survfit(Surv(x[,"OS_mes"],x[,"I_OS"])~x[,"HPV"],type="kaplan-meier")
plot(m)
# Pro dv skupiny ji program nekresl konfidenn ps
survdiff(Surv(x[,"OS_mes"],x[,"I_OS"])~x[,"HPV"],rho=0)

# Coxv model proporcionlnho hazardu (zvislost peit va vce 
#            kvalitativnch i kvantitativnch veliinch)
mc<-coxph(Surv(x[,"OS_mes"],x[,"I_OS"])~x[,"HPV"])
summary(mc)

# dv skupiny s exponencilnm pevnm
x<-read.csv("2exp.csv", header = TRUE)
xt<-x[,"OS"]
cx<-x[,"IOS"]
#  definice funkce pro exponenciln peit
ll <- function(m){
  s<-  sum(log(m[2]* dexp(xt[cx[]==1],m[1])+(1-m[2])*dexp(xt[cx[]==1],m[3])))
  s<-s+sum(log(m[2]*(pexp(xt[cx[]==0],m[1])+(1-m[2])*pexp(xt[cx[]==0],m[3]))))
  -s
}

# Musme zvolit odhad potench parametr (nap. .1,.9,.7) a pak jej spolen 
# s prv definovanou funkc ll pout ve funkci nlm()
mm<-nlm(ll,c(.1,.9,.7))
print(mm$estimate)
# a jet nakreslit obrzek
plot(survfit(Surv(xt,cx)~1),xlab="msce",ylab="pravdpodobnost peit",ylim=c(.6,1),
     new=FALSE,conf.int=F) 
pp<-mm[[2]][1]*(0:3000)
ppp<-mm[[2]][2]*(0:3000)
e<-mm[[2]][3]*exp(-pp)+(1-mm[[2]][3])*exp(-ppp)
lines(0:3000,e,lwd=2,col="red")





# Cenzorovan data (hodnoty pod deteknm limitem)
x<-read.csv("OHP.csv", header = TRUE)

# poty cenzorovanch dat  Procento cenzorovn je tm 85%
t<-table(x[,"CENZ"])
names(t)<-c("necenzorovno","cenzorovno")
t

# procenta cenzorovanch
100*t/sum(t)

# prmr necenzorovanch
mean(x[x[,"CENZ"]==0,"OHP"]) 

# prmr vech pokud msto cenzorovn nechme detekn limit
mean(x[,"OHP"]) 
xp<-x

# prmr pokud cenzorovan hodnoty nahradme nulou
xp[xp[,"CENZ"]==1,"OHP"]<-0
mean(xp[,"OHP"]) 

# sprvn vypoten prmr pomoc metod pro cenzorovan data a za pedpokladu 
# logaritmicko normlnho rozloen.
m<- survreg(Surv(x[,"OHP"],x[,"CENZ"],type="left")~ 1,dist='loggaussian')
summary(m)

# odhad geometrickho prmru
exp(m[[1]])

# tot za pedpokladu normlnho rozloen.
m<-survreg(formula=Surv(x[,"OHP"], x[,"CENZ"], type="left")~1, dist="gaussian")   
summary(m)

# odhad aritmetickho prmru
m[[1]]
