# oven typu rozloen
x<-read.csv("kovy.csv", header = TRUE)

# nsledujcm ulome nastaven grafickho vstupu do op
op<-par()
par(mfrow=c(1,2))

# nastavme parametry grafickho okna tak aby obsahovalo dva grafy
par(mar=c(4,1,0,1))

# Oven normality
# nejprve nakreslen histogramu
h<-hist(x[,"PB"],main="",ylab="",xlab="PB",freq=FALSE,yaxt="n")
p<-seq( min(h$breaks),max(h$breaks),length.out= 1000)

# nyn dokreslme hustotu normlnho rozloen
lines(p,dnorm(p,mean(x[,"PB"]),sd(x[,"PB"])),col="red")

# stle kreslme do jedn sti grafickho vstupu
# Novm grafem nasmrujeme vstupy do dal sti grafickho okna: 
# Tot provedeme po proveden logaritmick transformace
h<-hist(log(x[,"PB"]),main="",ylab="",xlab="log(PB)",freq=FALSE,ylim=c(0,1),yaxt="n")
p<-seq( min(h$breaks),max(h$breaks),length.out= 1000)
lines(p,dnorm(p,mean(log(x[,"PB"])),sd(log(x[,"PB"]))),col="blue")

# nsledujcm pkazem aktivujeme nastaven grafickho vstupu uloenho v op  a opt nastavme parametry grafickho vstupu
par(op)
par(mar=c(1,4,1,1))
x<-read.csv("pedi.csv", header = TRUE)

# Nyn nakreslme boxplot - krabicov grafy "vousat krabiky"
boxplot(x[,"HMOT_POR"]~as.factor(x[,"OKRES"]),ylab="Porodn hmotnost (g)",xaxt = "n")
 par(op)
x<-read.csv("kovy.csv", header = TRUE)
op<-par()
par(mfrow=c(1,2))

# Dal variantou oven typu rozloen je nakreslen Q-Q grafu
qqnorm(x[,"PB"],main="Q-Q graf pro normalitu",ylab="vbrov kvantil Pb",xlab="teoretick kvantil")

# do grafu pidme i pmku
qqline(x[,"PB"], col = "red",lwd=2)

# tot po logaritmick transformaci
qqnorm(log(x[,"PB"]),main="Q-Q graf pro normalitu",ylab="vbrov kvantil log(Pb)",xlab="teoretick kvantil")
qqline(log(x[,"PB"]), col = "blue",lwd=2)
 
# Nyn ji testy rozloen - normality:
library(nortest) 

# Chi kvadrt test dobr shody pro namen hodnoty 
pearson.test(x[,"PB"])
# Chi kvadrt test dobr shody pro namen hodnoty 
pearson.test(log(x[,"PB"]))

# Kolmogorovv-Smirnovv test pro namen hodnoty
ks.test(x[,"PB"], "pnorm", mean(x[,"PB"]), sd(x[,"PB"]))
# Wilkv-Shapirv test pro namen hodnoty 
shapiro.test(x[,"PB"])
# Kolmogorovv-Smirnovv test pro jejich logaritmy
ks.test(log(x[,"PB"]), "pnorm", mean(log(x[,"PB"])), sd(log(x[,"PB"])))
# Wilkv-Shapirv test pro jejich logaritmy 
shapiro.test(log(x[,"PB"]))

# Testy ikmosti a liatosti:
library(moments)
agostino.test(x[,"PB"])
anscombe.test(x[,"PB"])

# Grubbsv test odlehlch hodnot
library(outliers)
grubbs.test(x[,"PB"])
grubbs.test(log(x[,"PB"]))

# Robustn odhady Huberv M odhad
library(robustbase)
huberM(na.omit(x[,"PB"]))$mu

# useknut prmr:
# nejprve vypo4teme kvantily 
q<-quantile(na.omit(x[,"PB"]),c(.025,.975))
q
# a nyn ji meme vypost useknut odhad (musme ale eliminovat hodnoty NA)
mean(na.omit(x[(x[,"PB"]>q[1])&(x[,"PB"]<q[2]),"PB"]))

op<-par()
scan()
