# dvouvbrov testy  - porovnn dvou skupin
x<-read.csv("HDL_po_sk.csv", header = TRUE)

# t-test pro rzn rozptyly
t.test(x[,"CHOL_A"],x[,"CHOL_B"],var.equal = FALSE)

# t-test pro stejn rozptyly
t.test(x[,"CHOL_A"],x[,"CHOL_B"],var.equal = TRUE)

# F-test shody dvou rozptyl
var.test(x[,"CHOL_A"],x[,"CHOL_B"])
library(BSDA)

# znamnkov test
SIGN.test(x[,"CHOL_A"],x[,"CHOL_B"])

# wilcoxonv test
wilcox.test(x[,"CHOL_A"],x[,"CHOL_B"],conf.int =TRUE)

# prov test
x<-read.csv("HDL_odbery.csv", header = TRUE)
t.test(x[,"HDL1"],x[,"HDL2"],paired = TRUE)

# test  korelace pro prov deta
cor.test(x[,"HDL1"],x[,"HDL2"],na.rm=TRUE, method = "pearson")

# chybn pouit dvouvbtov t-testy pro "prov" data.
t.test(x[,"HDL1"],x[,"HDL2"],var.equal = FALSE)
t.test(x[,"HDL1"],x[,"HDL2"],var.equal = TRUE)

# Nyn nakonec tto kapitoly nakreslme graf 9.1   pro prov porovnn s nezvysle vypotenmi intervaly spolehlivosti                                          
library(agricolae)
library(Hmisc)
x<-read.csv("HDL_odbery.csv", header = TRUE)
CI<-matrix(c(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),3,7)

#  Kreslen obrzku
#  do matice CI dme poty, prmry a SD pro jednotliv odbry
n<-apply(x[,c("HDL1","HDL2","HDL3")], 2, function(x) length(na.omit(x)))
CI[,1]<-n
m<-apply(x[,c("HDL1","HDL2","HDL3")], 2, function(x) mean(na.omit(x)))
CI[,2]<-m
s<-apply(x[,c("HDL1","HDL2","HDL3")], 2, function(x) sd(na.omit(x)))
CI[,3]<-s
colnames(CI)<-c("N","prmr","SD","95%TMd","95%TMh","95%CId","95%CIh")
rownames(CI)<-c("1.odbr","2.odbr","3.odbr")

# Dle vypoteme tolerann intervaly a intervaly spolehlivosti
CI[,4]<-m-s*qt(.975,145)#/sqrt(n)
CI[,5]<-m+s*qt(.975,145)#/sqrt(n)
CI[,6]<-m-s*qt(.975,145)/sqrt(n)
CI[,7]<-m+s*qt(.975,145)/sqrt(n)
CI

# pro kreslen grafu nepotebujeme znt meze interval ale jejich rozdly, protoe
# je budeme kreslit jako sloupce nad sebou
CIpl<-c(0,0,0,0,0,0,0,0,0,0,0,0)
dim(CIpl)<-c(3,4)
CIpl[,1]<-CI[,4]
CIpl[,2]<-CI[,6]- CI[,4]
CIpl[,3]<-CI[,7]- CI[,6]
CIpl[,4]<-CI[,5]- CI[,7]
CIpl<-t(CIpl)
colnames(CIpl)<-c("1.odbr","2.odbr","3.odbr")

# nejprve nakreslme intervaly
barplot(CIpl,col=c("transparent","grey80","grey60","grey80"),
border="transparent",axisnames = TRUE,ylim=c(.5,2.2),
ylab="mmol/l",main="HDL Cholesterol")

# dle nakreslme prmry
xo<-c(.691489,1.882989,3.074489)
points(xo,CI[,2],pch=3,cex=2,lwd=4)

# a nakonec za kadho jedince jednu lomenou ru
for(i in 1:39){
 lines(xo,c(x[i,"HDL1"],x[i,"HDL2"],x[i,"HDL3"]))
}